/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  Contract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import { TypedEventFilter, TypedEvent, TypedListener } from "./commons";

interface ISpaceExchangeInterface extends ethers.utils.Interface {
  functions: {
    "acceptBid(uint256,tuple)": FunctionFragment;
    "bidForTokenBidder(uint256,address)": FunctionFragment;
    "bidSharesForToken(uint256)": FunctionFragment;
    "configure(address)": FunctionFragment;
    "currentAskForToken(uint256)": FunctionFragment;
    "isValidBid(uint256,uint256)": FunctionFragment;
    "isValidBidShares(tuple)": FunctionFragment;
    "removeAsk(uint256)": FunctionFragment;
    "removeBid(uint256,address)": FunctionFragment;
    "setAsk(uint256,tuple)": FunctionFragment;
    "setBid(uint256,tuple,address)": FunctionFragment;
    "setBidShares(uint256,tuple)": FunctionFragment;
    "splitShare(tuple,uint256)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "acceptBid",
    values: [
      BigNumberish,
      {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "bidForTokenBidder",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "bidSharesForToken",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "configure", values: [string]): string;
  encodeFunctionData(
    functionFragment: "currentAskForToken",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "isValidBid",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "isValidBidShares",
    values: [
      {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "removeAsk",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "removeBid",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "setAsk",
    values: [BigNumberish, { amount: BigNumberish; currency: string }]
  ): string;
  encodeFunctionData(
    functionFragment: "setBid",
    values: [
      BigNumberish,
      {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      string
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "setBidShares",
    values: [
      BigNumberish,
      {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "splitShare",
    values: [{ value: BigNumberish }, BigNumberish]
  ): string;

  decodeFunctionResult(functionFragment: "acceptBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "bidForTokenBidder",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "bidSharesForToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "configure", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "currentAskForToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "isValidBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "isValidBidShares",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "removeAsk", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "removeBid", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setAsk", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setBidShares",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "splitShare", data: BytesLike): Result;

  events: {
    "AskCreated(uint256,tuple)": EventFragment;
    "AskRemoved(uint256,tuple)": EventFragment;
    "BidCreated(uint256,tuple)": EventFragment;
    "BidFinalized(uint256,tuple)": EventFragment;
    "BidRemoved(uint256,tuple)": EventFragment;
    "BidShareUpdated(uint256,tuple)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AskCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "AskRemoved"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "BidCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "BidFinalized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "BidRemoved"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "BidShareUpdated"): EventFragment;
}

export class ISpaceExchange extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: ISpaceExchangeInterface;

  functions: {
    acceptBid(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "acceptBid(uint256,(uint256,address,address,address,(uint256)))"(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    bidForTokenBidder(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        }
      ]
    >;

    "bidForTokenBidder(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        }
      ]
    >;

    bidSharesForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber }
        ] & {
          prevOwner: [BigNumber] & { value: BigNumber };
          creator: [BigNumber] & { value: BigNumber };
          owner: [BigNumber] & { value: BigNumber };
        }
      ]
    >;

    "bidSharesForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        [
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber }
        ] & {
          prevOwner: [BigNumber] & { value: BigNumber };
          creator: [BigNumber] & { value: BigNumber };
          owner: [BigNumber] & { value: BigNumber };
        }
      ]
    >;

    configure(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "configure(address)"(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    currentAskForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[[BigNumber, string] & { amount: BigNumber; currency: string }]>;

    "currentAskForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[[BigNumber, string] & { amount: BigNumber; currency: string }]>;

    isValidBid(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    "isValidBid(uint256,uint256)"(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isValidBidShares(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    "isValidBidShares(((uint256),(uint256),(uint256)))"(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    removeAsk(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    removeBid(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "removeBid(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setAsk(uint256,(uint256,address))"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setBid(uint256,(uint256,address,address,address,(uint256)),address)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setBidShares(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    "setBidShares(uint256,((uint256),(uint256),(uint256)))"(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    splitShare(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    "splitShare((uint256),uint256)"(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;
  };

  acceptBid(
    tokenId: BigNumberish,
    expectedBid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "acceptBid(uint256,(uint256,address,address,address,(uint256)))"(
    tokenId: BigNumberish,
    expectedBid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  bidForTokenBidder(
    tokenId: BigNumberish,
    bidder: string,
    overrides?: CallOverrides
  ): Promise<
    [BigNumber, string, string, string, [BigNumber] & { value: BigNumber }] & {
      amount: BigNumber;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: [BigNumber] & { value: BigNumber };
    }
  >;

  "bidForTokenBidder(uint256,address)"(
    tokenId: BigNumberish,
    bidder: string,
    overrides?: CallOverrides
  ): Promise<
    [BigNumber, string, string, string, [BigNumber] & { value: BigNumber }] & {
      amount: BigNumber;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: [BigNumber] & { value: BigNumber };
    }
  >;

  bidSharesForToken(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    [
      [BigNumber] & { value: BigNumber },
      [BigNumber] & { value: BigNumber },
      [BigNumber] & { value: BigNumber }
    ] & {
      prevOwner: [BigNumber] & { value: BigNumber };
      creator: [BigNumber] & { value: BigNumber };
      owner: [BigNumber] & { value: BigNumber };
    }
  >;

  "bidSharesForToken(uint256)"(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<
    [
      [BigNumber] & { value: BigNumber },
      [BigNumber] & { value: BigNumber },
      [BigNumber] & { value: BigNumber }
    ] & {
      prevOwner: [BigNumber] & { value: BigNumber };
      creator: [BigNumber] & { value: BigNumber };
      owner: [BigNumber] & { value: BigNumber };
    }
  >;

  configure(
    spaceContractAddress: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "configure(address)"(
    spaceContractAddress: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  currentAskForToken(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<[BigNumber, string] & { amount: BigNumber; currency: string }>;

  "currentAskForToken(uint256)"(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<[BigNumber, string] & { amount: BigNumber; currency: string }>;

  isValidBid(
    tokenId: BigNumberish,
    bidAmount: BigNumberish,
    overrides?: CallOverrides
  ): Promise<boolean>;

  "isValidBid(uint256,uint256)"(
    tokenId: BigNumberish,
    bidAmount: BigNumberish,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isValidBidShares(
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: CallOverrides
  ): Promise<boolean>;

  "isValidBidShares(((uint256),(uint256),(uint256)))"(
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: CallOverrides
  ): Promise<boolean>;

  removeAsk(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "removeAsk(uint256)"(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  removeBid(
    tokenId: BigNumberish,
    bidder: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "removeBid(uint256,address)"(
    tokenId: BigNumberish,
    bidder: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setAsk(
    tokenId: BigNumberish,
    ask: { amount: BigNumberish; currency: string },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setAsk(uint256,(uint256,address))"(
    tokenId: BigNumberish,
    ask: { amount: BigNumberish; currency: string },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setBid(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    spender: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setBid(uint256,(uint256,address,address,address,(uint256)),address)"(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    spender: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setBidShares(
    tokenId: BigNumberish,
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  "setBidShares(uint256,((uint256),(uint256),(uint256)))"(
    tokenId: BigNumberish,
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  splitShare(
    sharePercentage: { value: BigNumberish },
    amount: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  "splitShare((uint256),uint256)"(
    sharePercentage: { value: BigNumberish },
    amount: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  callStatic: {
    acceptBid(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    "acceptBid(uint256,(uint256,address,address,address,(uint256)))"(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    bidForTokenBidder(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<
      [
        BigNumber,
        string,
        string,
        string,
        [BigNumber] & { value: BigNumber }
      ] & {
        amount: BigNumber;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: [BigNumber] & { value: BigNumber };
      }
    >;

    "bidForTokenBidder(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<
      [
        BigNumber,
        string,
        string,
        string,
        [BigNumber] & { value: BigNumber }
      ] & {
        amount: BigNumber;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: [BigNumber] & { value: BigNumber };
      }
    >;

    bidSharesForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        [BigNumber] & { value: BigNumber },
        [BigNumber] & { value: BigNumber },
        [BigNumber] & { value: BigNumber }
      ] & {
        prevOwner: [BigNumber] & { value: BigNumber };
        creator: [BigNumber] & { value: BigNumber };
        owner: [BigNumber] & { value: BigNumber };
      }
    >;

    "bidSharesForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<
      [
        [BigNumber] & { value: BigNumber },
        [BigNumber] & { value: BigNumber },
        [BigNumber] & { value: BigNumber }
      ] & {
        prevOwner: [BigNumber] & { value: BigNumber };
        creator: [BigNumber] & { value: BigNumber };
        owner: [BigNumber] & { value: BigNumber };
      }
    >;

    configure(
      spaceContractAddress: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "configure(address)"(
      spaceContractAddress: string,
      overrides?: CallOverrides
    ): Promise<void>;

    currentAskForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber, string] & { amount: BigNumber; currency: string }>;

    "currentAskForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber, string] & { amount: BigNumber; currency: string }>;

    isValidBid(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<boolean>;

    "isValidBid(uint256,uint256)"(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isValidBidShares(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<boolean>;

    "isValidBidShares(((uint256),(uint256),(uint256)))"(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<boolean>;

    removeAsk(tokenId: BigNumberish, overrides?: CallOverrides): Promise<void>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    removeBid(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "removeBid(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<void>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: CallOverrides
    ): Promise<void>;

    "setAsk(uint256,(uint256,address))"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: CallOverrides
    ): Promise<void>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "setBid(uint256,(uint256,address,address,address,(uint256)),address)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: CallOverrides
    ): Promise<void>;

    setBidShares(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    "setBidShares(uint256,((uint256),(uint256),(uint256)))"(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    splitShare(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "splitShare((uint256),uint256)"(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  filters: {
    AskCreated(
      tokenId: BigNumberish | null,
      ask: null
    ): TypedEventFilter<
      [
        BigNumber,
        [BigNumber, string] & { amount: BigNumber; currency: string }
      ],
      {
        tokenId: BigNumber;
        ask: [BigNumber, string] & { amount: BigNumber; currency: string };
      }
    >;

    AskRemoved(
      tokenId: BigNumberish | null,
      ask: null
    ): TypedEventFilter<
      [
        BigNumber,
        [BigNumber, string] & { amount: BigNumber; currency: string }
      ],
      {
        tokenId: BigNumber;
        ask: [BigNumber, string] & { amount: BigNumber; currency: string };
      }
    >;

    BidCreated(
      tokenId: BigNumberish | null,
      bid: null
    ): TypedEventFilter<
      [
        BigNumber,
        [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        }
      ],
      {
        tokenId: BigNumber;
        bid: [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        };
      }
    >;

    BidFinalized(
      tokenId: BigNumberish | null,
      bid: null
    ): TypedEventFilter<
      [
        BigNumber,
        [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        }
      ],
      {
        tokenId: BigNumber;
        bid: [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        };
      }
    >;

    BidRemoved(
      tokenId: BigNumberish | null,
      bid: null
    ): TypedEventFilter<
      [
        BigNumber,
        [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        }
      ],
      {
        tokenId: BigNumber;
        bid: [
          BigNumber,
          string,
          string,
          string,
          [BigNumber] & { value: BigNumber }
        ] & {
          amount: BigNumber;
          currency: string;
          bidder: string;
          recipient: string;
          sellOnShare: [BigNumber] & { value: BigNumber };
        };
      }
    >;

    BidShareUpdated(
      tokenId: BigNumberish | null,
      bidShares: null
    ): TypedEventFilter<
      [
        BigNumber,
        [
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber }
        ] & {
          prevOwner: [BigNumber] & { value: BigNumber };
          creator: [BigNumber] & { value: BigNumber };
          owner: [BigNumber] & { value: BigNumber };
        }
      ],
      {
        tokenId: BigNumber;
        bidShares: [
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber },
          [BigNumber] & { value: BigNumber }
        ] & {
          prevOwner: [BigNumber] & { value: BigNumber };
          creator: [BigNumber] & { value: BigNumber };
          owner: [BigNumber] & { value: BigNumber };
        };
      }
    >;
  };

  estimateGas: {
    acceptBid(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "acceptBid(uint256,(uint256,address,address,address,(uint256)))"(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    bidForTokenBidder(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "bidForTokenBidder(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    bidSharesForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "bidSharesForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    configure(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "configure(address)"(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    currentAskForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "currentAskForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isValidBid(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "isValidBid(uint256,uint256)"(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isValidBidShares(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "isValidBidShares(((uint256),(uint256),(uint256)))"(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    removeAsk(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    removeBid(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "removeBid(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setAsk(uint256,(uint256,address))"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setBid(uint256,(uint256,address,address,address,(uint256)),address)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setBidShares(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    "setBidShares(uint256,((uint256),(uint256),(uint256)))"(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    splitShare(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "splitShare((uint256),uint256)"(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    acceptBid(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "acceptBid(uint256,(uint256,address,address,address,(uint256)))"(
      tokenId: BigNumberish,
      expectedBid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    bidForTokenBidder(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "bidForTokenBidder(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    bidSharesForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "bidSharesForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    configure(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "configure(address)"(
      spaceContractAddress: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    currentAskForToken(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "currentAskForToken(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isValidBid(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "isValidBid(uint256,uint256)"(
      tokenId: BigNumberish,
      bidAmount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isValidBidShares(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "isValidBidShares(((uint256),(uint256),(uint256)))"(
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    removeAsk(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    removeBid(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "removeBid(uint256,address)"(
      tokenId: BigNumberish,
      bidder: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setAsk(uint256,(uint256,address))"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setBid(uint256,(uint256,address,address,address,(uint256)),address)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      spender: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setBidShares(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    "setBidShares(uint256,((uint256),(uint256),(uint256)))"(
      tokenId: BigNumberish,
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    splitShare(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "splitShare((uint256),uint256)"(
      sharePercentage: { value: BigNumberish },
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
